-----------------------------------------------------------------------------------------------
-- Client Lua Script for YBattleCommands
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
-- By: Yabco
-- Version: 0.1.1 

require "Window"
 
-----------------------------------------------------------------------------------------------
-- YBattleCommands Module Definition
-----------------------------------------------------------------------------------------------
local YBattleCommands = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
local sCmdNewMaskLeft = "New Moodie Mask on Bottom LEFT Spot!"
local sCmdNewMaskCenter = "New Moodie Mask on Bottom CENTER!"
local sCmdNewMaskTop = "New Moodie Mask on BRIDGE!"
local sCmdNewMaskRight = "New Moodie Mask on Bottom RIGHT Spot!"

local sCmdDefCarier = "Defend Our Mask Carier!"
local sCmdAttCarier = "Attack Enemy Mask Carier!"

local sCmdDefBase = "Defend Base!"
local sCmdSteal = "Steal Mask From Enemy!"

local sCmdOtherHeal = "Need Healing!"
local sCmdOtherAssist = "Assist Me!" -- on %target?
local sCmdOtherProtip1 = "Remember: Objectives > Kills!"
local sCmdOtherProtip2 = "Remember: If there isn't a mask close by and you're fighting you probably doing something wrong." 
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function YBattleCommands:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function YBattleCommands:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- YBattleCommands OnLoad
-----------------------------------------------------------------------------------------------
function YBattleCommands:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("YBattleCommands.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- YBattleCommands OnDocLoaded
-----------------------------------------------------------------------------------------------
function YBattleCommands:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "YBattleCommandsForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("bgc", "OnYBattleCommandsOn", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- YBattleCommands Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/bgc"
function YBattleCommands:OnYBattleCommandsOn()
	self.wndMain:Show(true) -- show the window
end


-----------------------------------------------------------------------------------------------
-- YBattleCommandsForm Functions
-----------------------------------------------------------------------------------------------
-- when the Cancel button is clicked
function YBattleCommands:OnCancel()
	self.wndMain:Show(false) -- hide the window
end

function YBattleCommands:OnCmdButton( wndHandler, wndControl, eMouseButton )
	local cmd = wndControl:GetText()
	
	if cmd == "Left" then
		ChatSystemLib.Command('/Instance ' .. sCmdNewMaskLeft)
	elseif cmd == "Center" then
		ChatSystemLib.Command('/Instance ' .. sCmdNewMaskCenter)
	elseif cmd == "Top" then
		ChatSystemLib.Command('/Instance ' .. sCmdNewMaskTop)
	elseif cmd == "Right" then
		ChatSystemLib.Command('/Instance ' .. sCmdNewMaskRight)
	elseif cmd == "Defend" then
		ChatSystemLib.Command('/Instance ' .. sCmdDefCarier)
	elseif cmd == "Attack" then
		ChatSystemLib.Command('/Instance ' .. sCmdAttCarier)
	elseif cmd == "Defend Base" then
		ChatSystemLib.Command('/Instance ' .. sCmdDefBase)
	elseif cmd == "Steal Mask" then
		ChatSystemLib.Command('/Instance ' .. sCmdSteal)
	elseif cmd == "Heal" then
		ChatSystemLib.Command('/Instance ' .. sCmdOtherHeal)
	elseif cmd == "Assist" then
		ChatSystemLib.Command('/Instance ' .. sCmdOtherAssist)
	elseif cmd == "Protip1" then
		ChatSystemLib.Command('/Instance ' .. sCmdOtherProtip1)
	elseif cmd == "Protip2" then
		ChatSystemLib.Command('/Instance ' .. sCmdOtherProtip2)
	end
end

-----------------------------------------------------------------------------------------------
-- YBattleCommands Instance
-----------------------------------------------------------------------------------------------
local YBattleCommandsInst = YBattleCommands:new()
YBattleCommandsInst:Init()
